function [f,G,H]=fgh(z, ID, Y, X, Z1,Z2, Delta, N,n, ww, BB, XX, ...
                    indsub, Eindsub, indy, m, nn, indHZ, indPAR, indexp)

% indy=(Y>=yy) insub=(subject indicator)
par=z;
par(indexp)=exp(z(indexp));

hz=par(indHZ);
theta=par(indPAR);
tbeta=theta(1); tsig11=abs(theta(2)); tsig12=theta(3); 
tsig22=abs(theta(4));


%tempdet=tsig11*tsig22-tsig12^2;
%if (tempdet>0.01 & tsig11>0.01 & tsig22>0.01)
    Tsigma=repmat(tsig11.*Z1.*Z1+2*tsig12*Z1.*Z2+tsig22*Z2.*Z2,1,m);
    Isig=1./(2*sqrt(Tsigma));
    
    Z11=repmat(Z1.*Z1,1,m).*Isig;
    Z12=2*repmat(Z1.*Z2,1,m).*Isig;
    Z22=repmat(Z2.*Z2,1,m).*Isig;
    
    
    Im=repmat(1,m,1);
    HZ=indy*hz;
    p=exp(-tbeta*XX-sqrt(Tsigma).*BB);
    q=repmat(HZ,1,m)+p; 
    rr=exp(indsub*(log(p)-(1+repmat(Delta,1,m)).*log(q)));
    alpha=rr*ww;
    WR=repmat(ww',n,1).*rr./repmat(alpha,1,m);
        
    Ttemp1=(1+repmat(Delta, 1,m))./q;
    Ttemp2=(1+repmat(Delta, 1,m))./power(q,2);
    
    DR=zeros(N,m);
    for i=1:1:n
        DR(ID==i,:)=repmat(WR(i,:),sum(ID==i),1);
    end
    Tgamma=-indsub*(repmat((DR.*Ttemp1)*Im,1,nn).*indy); % n by s
    
    % xi n by m
    xitemp=(-1+(1+repmat(Delta,1,m)).*p./q);
    xix=indsub*(XX.*xitemp);   
    xisig11=indsub*(Z11.*BB.*xitemp); 
    xisig12=indsub*(Z12.*BB.*xitemp); 
    xisig22=indsub*(Z22.*BB.*xitemp);
    
    % mu n by 1
    mux=(WR.*xix)*Im;
    musig11=(WR.*xisig11)*Im;
    musig12=(WR.*xisig12)*Im;
    musig22=(WR.*xisig22)*Im;
    
    
    % derivatives
    vtemp=(1+repmat(Delta,1,m)).*p./power(q,2);
    vx=XX.*vtemp;  
    vsig11=Z11.*BB.*vtemp; 
    vsig12=Z12.*BB.*vtemp; 
    vsig22=Z22.*BB.*vtemp;
    
    stemp=(1+repmat(Delta,1,m)).*(-p./q+power(p,2)./power(q,2));
    Tstemp=power(BB,2).*stemp-BB.*xitemp./sqrt(Tsigma);
    sx11=indsub*(XX.*XX.*stemp)+xix.*xix; 
    sx12=indsub*(XX.*Z11.*BB.*stemp)+xix.*xisig11; 
    sx13=indsub*(XX.*Z12.*BB.*stemp)+xix.*xisig12;
    sx14=indsub*(XX.*Z22.*BB.*stemp)+xix.*xisig22;
    sx22=indsub*(Z11.*Z11.*Tstemp)+xisig11.*xisig11; 
    sx23=indsub*(Z11.*Z12.*Tstemp)+xisig11.*xisig12;
    sx24=indsub*(Z11.*Z22.*Tstemp)+xisig11.*xisig22;
    sx33=indsub*(Z12.*Z12.*Tstemp)+xisig12.*xisig12; 
    sx34=indsub*(Z12.*Z22.*Tstemp)+xisig12.*xisig22;
    sx44=indsub*(Z22.*Z22.*Tstemp)+xisig22.*xisig22;
    
    %f, g, H
    f=sum(log(hz))+sum(log(alpha));
    
    G=zeros(length(z),1);
    G(indHZ)=1./hz+(sum(Tgamma))';
    tempmu=[mux,musig11,musig12,musig22];
    G(indPAR)=(sum(tempmu))';
    
    
    H=zeros(length(z),length(z));
    H(indHZ,indHZ)=H(indHZ,indHZ)-diag(1./power(hz,2))-Tgamma'*Tgamma;
    tempH=(DR.*Ttemp2)*Im;
    H(indHZ,indHZ)=H(indHZ,indHZ)+indy'*(repmat(tempH,1,nn).*indy);
  
    for i=1:1:m
        tempHi=indsub*(repmat(Ttemp1(:,i),1,nn).*indy);
        H(indHZ,indHZ)=H(indHZ,indHZ)+tempHi'*(repmat(WR(:,i),1,nn).*tempHi);
    end

    H(indHZ, indPAR)=H(indHZ, indPAR)-Tgamma'*tempmu;
    Txix=zeros(N,m);
    Txisig11=zeros(N,m);
    Txisig12=zeros(N,m);
    Txisig22=zeros(N,m);
    for i=1:1:n
        Txix(ID==i,:)=repmat(xix(i,:),sum(ID==i),1);
        Txisig11(ID==i,:)=repmat(xisig11(i,:),sum(ID==i),1);
        Txisig12(ID==i,:)=repmat(xisig12(i,:),sum(ID==i),1);
        Txisig22(ID==i,:)=repmat(xisig22(i,:),sum(ID==i),1);
    end
    H(indHZ,indPAR(1))=H(indHZ,indPAR(1))-indy'*((DR.*Ttemp1.*Txix)*Im)-indy'*((DR.*vx)*Im);
    H(indHZ,indPAR(2))=H(indHZ,indPAR(2))-indy'*((DR.*Ttemp1.*Txisig11)*Im)-indy'*((DR.*vsig11)*Im);
    H(indHZ,indPAR(3))=H(indHZ,indPAR(3))-indy'*((DR.*Ttemp1.*Txisig12)*Im)-indy'*((DR.*vsig12)*Im);
    H(indHZ,indPAR(4))=H(indHZ,indPAR(4))-indy'*((DR.*Ttemp1.*Txisig22)*Im)-indy'*((DR.*vsig22)*Im);
    H(indPAR, indHZ)=H(indHZ,indPAR)';
    
    H(indPAR(1),indPAR(1))=H(indPAR(1),indPAR(1))+sum(sum(WR.*sx11));
    H(indPAR(1),indPAR(2))=H(indPAR(1),indPAR(2))+sum(sum(WR.*sx12));
    H(indPAR(1),indPAR(3))=H(indPAR(1),indPAR(3))+sum(sum(WR.*sx13));
    H(indPAR(1),indPAR(4))=H(indPAR(1),indPAR(4))+sum(sum(WR.*sx14));
    H(indPAR(2),indPAR(2))=H(indPAR(2),indPAR(2))+sum(sum(WR.*sx22));
    H(indPAR(2),indPAR(3))=H(indPAR(2),indPAR(3))+sum(sum(WR.*sx23));
    H(indPAR(2),indPAR(4))=H(indPAR(2),indPAR(4))+sum(sum(WR.*sx24));
    H(indPAR(3),indPAR(3))=H(indPAR(3),indPAR(3))+sum(sum(WR.*sx33));
    H(indPAR(3),indPAR(4))=H(indPAR(3),indPAR(4))+sum(sum(WR.*sx34));
    H(indPAR(4),indPAR(4))=H(indPAR(4),indPAR(4))+sum(sum(WR.*sx44));
    H(indPAR,indPAR)=H(indPAR,indPAR)+H(indPAR,indPAR)'-diag(diag(H(indPAR,indPAR)));
    H(indPAR,indPAR)=H(indPAR,indPAR)-tempmu'*tempmu;
     
    
    f=-f/n;    G=-G/n;    H=-H/n;
    
    tempdet=tsig11*tsig22-tsig12^2;
    epsilon=1000; sigdet=(tempdet<=0.1);
    
    f=f+epsilon*sigdet*(tempdet-0.1)^4;
    G(indPAR(2:4))=G(indPAR(2:4))+epsilon*sigdet*4*(tempdet-0.1)^3*[tsig22;-2*tsig12;tsig11];
    H(indPAR(2:4),indPAR(2:4))=H(indPAR(2:4),indPAR(2:4))...
     +epsilon*sigdet*4*(3*(tempdet-0.1)^2*[tsig22;-2*tsig12;tsig11]*[tsig22;-2*tsig12;tsig11]'...
                       +(tempdet-0.1)^3*[0,0,1;0,-2,0;1,0,0]);
    
    
    
    
    Comind=setdiff((1:1:length(z))',indexp);
        
    G(indexp)=G(indexp).*par(indexp);
    
    H(indexp,indexp)=H(indexp,indexp).*(par(indexp)*par(indexp)')+diag(G(indexp));
    H(indexp,Comind)=H(indexp,Comind).*repmat(par(indexp),1,length(Comind));
    H(Comind,indexp)=H(indexp,Comind)';
% else
%       f=100000;
%       G=1+zeros(length(z),1);
%       H=1+zeros(length(z),length(z));
% end
